Star

LeetCode 279.Perfect Squares

Question

Given a positive integer n, find the least number of perfect square numbers (for example, 1, 4, 9, 16, ...) which sum to n.

For example, given n = 12, return 3 because 12 = 4 + 4 + 4; given n = 13, return 2 because 13 = 4 + 9.

Explanation

动态规划方法就是把一次得到最小值。然后把一个数i拆分成 i-jj和jj。

Code

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
public class Solution {
public int numSquares(int n) {
// DP solution:
int[] nums = new int[n+1];
if (n == 0) return 0;
Arrays.fill(nums, Integer.MAX_VALUE);
nums[0] = 0;
for (int i=1; i<=n; i++) {
int min = Integer.MAX_VALUE;
int j = 1;
while (i - j*j > 0) {
min = Math.min(min, nums[i-j*j]+1);
j++;
}
nums[i] = min;
}
return nums[n];
}
}